

 
const scPlayerBridgeFactory_contractID = "@mozilla.org/xtf/element-factory;1?namespace=http://scenari--platform.org/player/bridge";
const scPlayerBridgeFactory_CID = Components.ID("{8736259E-E256-4422-809A-42E11458002B}");

const scIPlayerBridge = Components.interfaces.scIPlayerBridge;

const nsIXTFElementFactory = Components.interfaces.nsIXTFElementFactory;
const nsIXTFElement = Components.interfaces.nsIXTFElement;
const nsIXTFGenericElement = Components.interfaces.nsIXTFGenericElement;

const nsISupports              = Components.interfaces.nsISupports;
const nsIComponentRegistrar    = Components.interfaces.nsIComponentRegistrar;
const nsIFactory               = Components.interfaces.nsIFactory;
const nsIModule                = Components.interfaces.nsIModule;
const nsIConsoleService 	   = Components.interfaces.nsIConsoleService;



function scPlayerBridge() {
}
scPlayerBridge.prototype = {
	/* nsIXTFElement */
	
	elementType : nsIXTFElement.ELEMENT_TYPE_GENERIC_ELEMENT,
	isAttributeHandler : false,
	getScriptingInterfaces : function(pCount) {
		pCount.value = 1;
		return [scIPlayerBridge];

	},
	
	handleDefault : function (pEvent) {
		return false;
	},
	
	willChangeDocument : function (pNewDoc) {},
	documentChanged : function (pNewDoc) {},
	willChangeParent : function (pNewParent) {},
	parentChanged : function (pNewParent) {},
	willInsertChild : function (pChild, pIndex) {},
	childInserted : function (pChild, pIndex) {},
	willAppendChild : function (pChild) {},
	childAppended : function (pChild) {},
	willRemoveChild : function (pIndex) {},
	childRemoved : function (pIndex) {},
	willSetAttribute : function (pName, pNewValue) {},
	attributeSet : function (pName, pNewValue) {},
	willRemoveAttribute : function (pName) {},
	attributeRemoved : function (pName) {},
	
	beginAddingChildren : function () {},
	doneAddingChildren : function () {},
	
	cloneState : function (pElement) {},
	
	onDestroyed : function() {},
		
	getData : function(pKey) {
		var vSession = this._eltWrapper.documentFrameElement.ownerDocument.defaultView.deskplayer._currentSession;
		if(vSession) return vSession.getData(pKey);
		return null;
		/*
		debug("elementNode::::\n"+getXml(this._eltWrapper.elementNode));
		debug("documentFrameElement::::\n"+getXml(this._eltWrapper.documentFrameElement));
		*/
	},
	setData : function(pKey, pValue) {
		var vSession = this._eltWrapper.documentFrameElement.ownerDocument.defaultView.deskplayer._currentSession;
		if(vSession) vSession.setData(pKey, pValue);
	},

	/* nsIXTFGenericElement */
	onCreated : function(pEltWrapper) {
		this._eltWrapper = pEltWrapper;
	},

	/* nsISupports */
	QueryInterface : function (iid) {
		if (iid.equals(nsIXTFGenericElement) || iid.equals(nsIXTFElement) || iid.equals(nsISupports) || iid.equals(scIPlayerBridge) ) return this;
		throw Components.results.NS_ERROR_NO_INTERFACE;
	}
}


var scPlayerBridgeFactory = {
	/* nsIXTFElementFactory */
	createElement : function(pTagName) {
		switch (pTagName) {
			case "scPlayerBridge" : return new scPlayerBridge();
		}
	},

	/* nsIFactory */
	createInstance : function (outer, iid) {
		if (outer != null) throw Components.results.NS_ERROR_NO_AGGREGATION;
		return this.QueryInterface(iid);
	},
	lockFactory : function mdh_lock(lock) {

	},

	/* nsISupports */
	QueryInterface : function (iid) {
 		if (iid.equals(nsIXTFElementFactory) || iid.equals(nsIFactory) || iid.equals(nsISupports)) return this;
		throw Components.results.NS_ERROR_NO_INTERFACE;
	}
};



var Module = {
  /* nsIModule */
  getClassObject : function mod_gch(compMgr, cid, iid) {
    if (cid.equals(scPlayerBridgeFactory_CID)) return scPlayerBridgeFactory.QueryInterface(iid);
    throw components.results.NS_ERROR_FAILURE;
  },

  registerSelf : function mod_regself(compMgr, fileSpec, location, type) {
	try {
    var vCompReg = compMgr.QueryInterface(nsIComponentRegistrar);
    vCompReg.registerFactoryLocation(scPlayerBridgeFactory_CID,
                                    "scPlayerBridge",
                                    scPlayerBridgeFactory_contractID,
                                    fileSpec,
                                    location,
                                    type);
	}catch(e){debug("registerSelf failed:::"+e);}
  },

  unregisterSelf : function mod_unreg(compMgr, location, type) {
    var vCompReg = compMgr.QueryInterface(nsIComponentRegistrar);
    vCompReg.unregisterFactoryLocation(scPlayerBridgeFactory_CID, location);
  },

  canUnload : function (compMgr) {
    return true;
  },
  
  /* nsISupports */
  QueryInterface : function mod_QI(iid) {
    if (iid.equals(nsIModule) || iid.equals(nsISupports)) return this;
    throw Components.results.NS_ERROR_NO_INTERFACE;
  }
};
function NSGetModule(compMgr, fileSpec) {
  return Module;
}





function debug(pText){
	var vConsoleService = Components.classes["@mozilla.org/consoleservice;1"].getService(nsIConsoleService);
	vConsoleService.logStringMessage(pText);
}

function listProperties (pObj){
	var vRes = "";
	var vProp = null;
	for (vProp in pObj) {
		try {
			vRes += vProp +'(' + pObj[vProp]+ ')'+ "\n";
		} catch(e){
			vRes += vProp +' -> toString in error\n';
		}
	}
	return vRes;
}

function getXml(pElement) {
	if( ! pElement) return "";
	var vSer = Components.classes["@mozilla.org/xmlextras/xmlserializer;1"].createInstance(Components.interfaces.nsIDOMSerializer);
	return vSer.serializeToString(pElement);
}